You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

45 lines
1002 B

  1. #!/bin/sh
  2. set -e
  3. process_filespec() {
  4. local src_dir="$1"
  5. local dst_dir="$2"
  6. local filespec="$3"
  7. echo "$filespec" | (
  8. IFS='|'
  9. while read fop fspec fperm; do
  10. local fop=`echo "$fop" | tr -d ' \t\n'`
  11. if [ "$fop" = "+" ]; then
  12. if [ ! -e "${src_dir}${fspec}" ]; then
  13. echo "File not found '${src_dir}${fspec}'"
  14. exit 1
  15. fi
  16. dpath=`dirname "$fspec"`
  17. if [ -z "$fperm" ]; then
  18. dperm=`stat -c "%a" ${src_dir}${dpath}`
  19. fi
  20. mkdir -p -m$dperm ${dst_dir}${dpath}
  21. echo "copying: '$fspec'"
  22. cp -fpR ${src_dir}${fspec} ${dst_dir}${dpath}/
  23. if [ -n "$fperm" ]; then
  24. chmod -R $fperm ${dst_dir}${fspec}
  25. fi
  26. elif [ "$fop" = "-" ]; then
  27. echo "removing: '$fspec'"
  28. rm -fR ${dst_dir}${fspec}
  29. elif [ "$fop" = "=" ]; then
  30. echo "setting permissions: '$fperm' on '$fspec'"
  31. chmod -R $fperm ${dst_dir}${fspec}
  32. fi
  33. done
  34. )
  35. }
  36. src_dir="$1"
  37. dst_dir="$2"
  38. filespec="$3"
  39. process_filespec "$src_dir" "$dst_dir" "$filespec" || {
  40. echo "process filespec error-ed"
  41. exit 1
  42. }